//
//    File: viewpointdialog.h
//
//    (C) 2000 Helmut Cantzler
//
//    Licensed under the terms of the Lesser General Public License.
//

#ifndef _VIEWPOINTDIALOG_H
#define _VIEWPOINTDIALOG_H

#include <qdialog.h>
#include <qtable.h>
#include "glmesh.h"

class QLineEdit;

class DoubleItem : public QTableItem
{
 public:
  DoubleItem(QTable* table, float l, float h, const float &f);
 
  QWidget* createEditor() const;

 private:
  float low, high;
};

class ViewpointDialog : public QDialog
{
  Q_OBJECT
 public:
  ViewpointDialog(QWidget *parent, GLMesh_Settings *s, const char *name=0);

 private slots:
  void accept();

 private:
  GLMesh_Settings *settings;

  QTable *table;
  QLineEdit *xshift, *yshift, *zshift, *clipping;
};

#endif
