//
//    File: image.h
//
//    (C) 2000 Helmut Cantzler
//
//    Licensed under the terms of the Lesser General Public License.
//

#ifndef _IMAGE_H
#define _IMAGE_H

#define MAX_WIDTH 4048
#define MAX_HEIGHT 4048

#include <stdio.h>
#include "array3d.h"

class Image
{
public:
  Image();
  ~Image();

  int read_jpeg(const char *filename);

  int height(void) const;
  int width(void) const;
  int pixel_size(void) const;
  const unsigned char* data(void) const;

  const unsigned char* scale_by_sampling(int height, int width);

  void grey_to_rgb(void);

private:
  Array3D<unsigned char> *image_data, *new_data;
  int image_height, image_width, image_pixel_size;
};

#endif
