//
//    File: texture.h
//
//    (C) 2000 Helmut Cantzler
//
//    Licensed under the terms of the Lesser General Public License.
//

#ifndef _TEXTURE_H
#define _TEXTURE_H

#include <GL/gl.h>
#include "image.h"

class Texture
{
public:
  Texture();
  ~Texture();

  int read(const char *f);

  int height(void) const;
  int width(void) const;
  int color_components(void) const;
  GLenum format(void) const;

  const unsigned char* data(void) const;

  int id;

private:
  Image *image;
  GLenum texture_format;
  int max_size;
};

#endif
